import { PontxMocksPlugin, PontManager } from "pontx-manager";
import * as PontxSpec from "pontx-spec";
export declare const TYPE_TS = "\nexport type APIMocks<API extends { request: any }> = API[\"request\"];\n\nexport type ControllerMocks<Controller extends { [x: string]: any }> = {\n  [K in keyof Controller]?: APIMocks<Controller[K]>;\n};\n";
export type MocksOptions = {
    schemaMapper?: Function;
    mocksDataMapper?: Function;
};
export declare class DefaultPontxMocksPlugin extends PontxMocksPlugin {
    getOptions(manager: PontManager, options: any): MocksOptions;
    getPreMocksData(manager: PontManager, options?: any): Promise<{
        [x: string]: any;
    }>;
    apply(manager: PontManager, options?: any): Promise<void>;
    getAPIMockCode(manager: PontManager, options: any, apiName: string, modName: string, specName: string): Promise<string>;
    static getFileStructure(manager: PontManager, options: MocksOptions, mocksData: any): {
        "index.ts": string;
    } | {
        [x: string]: {
            "index.ts": string;
        };
    };
    static getSpecFileStructure(spec: PontxSpec.PontSpec, options: MocksOptions, mocksData: any): {
        "index.ts": string;
    } | {
        [x: string]: {
            "index.ts": string;
        };
    };
    static generateMocksCode(manager: PontManager, options: MocksOptions, mocksData: any): Promise<void>;
}
export default DefaultPontxMocksPlugin;
//# sourceMappingURL=index.d.ts.map