"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DefaultPontxMocksPlugin = exports.TYPE_TS = void 0;
const pontx_manager_1 = require("pontx-manager");
const pontx_generate_1 = require("pontx-generate");
const PontxSpec = __importStar(require("pontx-spec"));
const jsf = __importStar(require("json-schema-faker"));
const fp = __importStar(require("lodash/fp"));
const _ = __importStar(require("lodash"));
const path = __importStar(require("path"));
const config_1 = require("pontx-manager/lib/config");
const ts = __importStar(require("typescript"));
const utils_1 = require("./utils");
exports.TYPE_TS = `
export type APIMocks<API extends { request: any }> = API["request"];

export type ControllerMocks<Controller extends { [x: string]: any }> = {
  [K in keyof Controller]?: APIMocks<Controller[K]>;
};
`;
class DefaultPontxMocksPlugin extends pontx_manager_1.PontxMocksPlugin {
    getOptions(manager, options) {
        const schemaMapperFile = options === null || options === void 0 ? void 0 : options.schemaMapper;
        const mocksOptions = {
            schemaMapper: (id) => id,
            mocksDataMapper: (value) => value,
        };
        if (schemaMapperFile) {
            const schemaMapperModule = (0, config_1.requireModule)(schemaMapperFile, manager.innerManagerConfig.configDir, manager.innerManagerConfig.rootDir);
            mocksOptions.schemaMapper = schemaMapperModule === null || schemaMapperModule === void 0 ? void 0 : schemaMapperModule.default;
        }
        return mocksOptions;
    }
    getPreMocksData(manager, options) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const mocksPath = path.join(manager.innerManagerConfig.outDir, "mocks/index.ts");
                const program = ts.createProgram([mocksPath], {
                    outDir: path.join(manager.innerManagerConfig.rootDir, "node_modules/.pontx/mocks"),
                    rootDir: path.join(manager.innerManagerConfig.outDir, "mocks"),
                    noEmit: false,
                    target: ts.ScriptTarget.ES2015,
                    module: ts.ModuleKind.CommonJS,
                    moduleResolution: ts.ModuleResolutionKind.NodeJs,
                    experimentalDecorators: true,
                    allowJs: true,
                });
                program.emit();
                const compiledFilePath = path.join(manager.innerManagerConfig.rootDir, "node_modules/.pontx/mocks/index.js");
                const currentMocksIndex = (0, pontx_manager_1.requireUncached)(compiledFilePath);
                const currentMocksData = yield (0, utils_1.mapPromiseValues)(_.mapValues(currentMocksIndex, (mod) => {
                    return (0, utils_1.mapPromiseValues)(_.mapValues(mod, (api) => {
                        if (typeof api === "function") {
                            return api();
                        }
                        return (0, utils_1.mapPromiseValues)(_.mapValues(api, (mocks) => {
                            return mocks();
                        }));
                    }));
                }));
                return currentMocksData;
            }
            catch (e) {
                console.log(e.stack);
            }
        });
    }
    apply(manager, options) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const mocksOptions = this.getOptions(manager, options);
                const currentMocksData = yield this.getPreMocksData(manager, options);
                DefaultPontxMocksPlugin.generateMocksCode(manager, mocksOptions, currentMocksData);
            }
            catch (e) {
                console.log(e.stack);
                this.logger.error(e.message);
            }
        });
    }
    getAPIMockCode(manager, options, apiName, modName, specName) {
        var _a, _b;
        return __awaiter(this, void 0, void 0, function* () {
            const mocksOptions = this.getOptions(manager, options);
            const spec = (_a = manager.localPontSpecs) === null || _a === void 0 ? void 0 : _a.find((spec) => spec.name === specName);
            const oas3Spec = transformSchema(buildOas3Spec(spec), mocksOptions.schemaMapper);
            const generator = new MocksCodeGenerator(oas3Spec, mocksOptions);
            const namespacePath = (oas3Spec === null || oas3Spec === void 0 ? void 0 : oas3Spec.name) ? `API.${oas3Spec.name}.${modName}` : `API.${modName}`;
            const api = (_b = oas3Spec === null || oas3Spec === void 0 ? void 0 : oas3Spec.apis) === null || _b === void 0 ? void 0 : _b[`${modName}/${apiName}`];
            return [
                `export const ${api.name}: typeof ${namespacePath}.${api.name}.request = async (params) => {`,
                `  return ${generator.generateAPIMocksCode(modName, api, 4)};`,
                `};`,
            ].join("\n");
        });
    }
    static getFileStructure(manager, options, mocksData) {
        if (manager.localPontSpecs.length === 1 && !manager.localPontSpecs[0].name) {
            return DefaultPontxMocksPlugin.getSpecFileStructure(manager.localPontSpecs[0], options, mocksData);
        }
        if (manager.localPontSpecs.length >= 1) {
            const result = manager.localPontSpecs
                .map((spec) => DefaultPontxMocksPlugin.getSpecFileStructure(spec, options, mocksData === null || mocksData === void 0 ? void 0 : mocksData[spec.name]))
                .reduce((pre, curr) => {
                return Object.assign(Object.assign({}, pre), curr);
            }, {});
            result["index.ts"] = manager.localPontSpecs
                .map((spec) => {
                return `export * as ${spec.name} from './${spec.name}/index';`;
            })
                .join("\n");
            return result;
        }
        return {};
    }
    static getSpecFileStructure(spec, options, mocksData) {
        const oas3Spec = transformSchema(buildOas3Spec(spec), options.schemaMapper);
        const generator = new MocksCodeGenerator(oas3Spec, options, mocksData);
        const specStructure = {
            ["index.ts"]: generator.generateSpecIndexCode(),
        };
        const mods = PontxSpec.PontSpec.getMods(oas3Spec);
        mods.forEach((mod) => {
            if (typeof mod.name === "string") {
                specStructure[mod.name] = generator.generateModMocksCode(mod);
            }
            else {
                specStructure["mod"] = generator.generateModMocksCode(mod);
            }
        });
        if (oas3Spec.name) {
            return { [oas3Spec.name]: specStructure };
        }
        return specStructure;
    }
    static generateMocksCode(manager, options, mocksData) {
        return __awaiter(this, void 0, void 0, function* () {
            const fileStructure = DefaultPontxMocksPlugin.getFileStructure(manager, options, mocksData);
            yield (0, pontx_generate_1.generateFiles)(fileStructure, path.join(manager.innerManagerConfig.outDir, "mocks"));
        });
    }
}
exports.DefaultPontxMocksPlugin = DefaultPontxMocksPlugin;
class MocksCodeGenerator {
    constructor(oas3Spec, options, preMocksData) {
        this.oas3Spec = oas3Spec;
        this.options = options;
        this.preMocksData = preMocksData;
        if (!options.schemaMapper) {
            this.options.schemaMapper = (schema) => schema;
        }
    }
    generateSpecIndexCode() {
        const mods = PontxSpec.PontSpec.getMods(this.oas3Spec);
        return mods
            .map((mod) => {
            return `export * as ${mod.name} from './${mod.name}';`;
        })
            .join("\n");
    }
    generateSchemaMocksData(schema) {
        const mocksSchema = Object.assign({ definitions: this.oas3Spec.definitions }, schema);
        try {
            jsf.JSONSchemaFaker.option("failOnInvalidFormat", false);
            const result = jsf.JSONSchemaFaker.generate(mocksSchema);
            return result;
        }
        catch (e) {
            debugger;
        }
    }
    generateAPIMocksCode(modName, api, indentationCnt = 4) {
        var _a, _b;
        const schema = (_b = (_a = api === null || api === void 0 ? void 0 : api.responses) === null || _a === void 0 ? void 0 : _a["200"]) === null || _b === void 0 ? void 0 : _b.schema;
        let mocksData = null;
        if (!this.preMocksData && schema) {
            mocksData = this.generateSchemaMocksData(schema);
        }
        else if (this.preMocksData) {
            mocksData = _.get(this.preMocksData, `${modName}.${api.name}`);
        }
        else {
            return "";
        }
        const mocksCode = JSON.stringify(mocksData, null, 2);
        return (0, pontx_generate_1.indentation)(indentationCnt)(mocksCode).trimStart();
    }
    generateModMocksCode(mod) {
        var _a;
        const namespace = mod.name;
        const namespacePath = ((_a = this.oas3Spec) === null || _a === void 0 ? void 0 : _a.name) ? `API.${this.oas3Spec.name}.${namespace}` : `API.${namespace}`;
        if (mod.interfaces.length) {
            const apiFiles = mod.interfaces
                .map((api) => {
                return [
                    `export const ${api.name}: typeof ${namespacePath}.${api.name}.request = async (params) => {`,
                    `  return ${this.generateAPIMocksCode(mod.name, api, 4)};`,
                    `};`,
                ].join("\n");
            })
                .reduce((result, code, index) => {
                return Object.assign(Object.assign({}, result), { [mod.interfaces[index].name + ".ts"]: code });
            }, {});
            return Object.assign({ "index.ts": mod.interfaces.map((api) => `export * from './${api.name}';`).join("\n") }, apiFiles);
        }
    }
}
const buildOas3Spec = (spec) => {
    const newDefs = {};
    const transformOas2Schema = (schema) => {
        var _a, _b;
        const { originRef, templateArgs, typeName } = schema, rest = __rest(schema, ["originRef", "templateArgs", "typeName"]);
        if (((_a = schema.templateArgs) === null || _a === void 0 ? void 0 : _a.length) && (schema === null || schema === void 0 ? void 0 : schema.typeName) && ((_b = spec.definitions) === null || _b === void 0 ? void 0 : _b[schema.typeName]) && (schema === null || schema === void 0 ? void 0 : schema.originRef)) {
            const defSchema = spec.definitions[schema.typeName];
            const newDef = PontxSpec.PontJsonSchema.mapPontxSchema(defSchema, (childSchema) => {
                if ((childSchema === null || childSchema === void 0 ? void 0 : childSchema.templateIndex) !== -1 && typeof (childSchema === null || childSchema === void 0 ? void 0 : childSchema.templateIndex) === "number") {
                    return schema.templateArgs[childSchema.templateIndex];
                }
                return childSchema;
            });
            newDefs[schema === null || schema === void 0 ? void 0 : schema.originRef] = newDef;
            return Object.assign({ $ref: "#/definitions/" + schema.originRef }, rest);
        }
        return schema;
    };
    const allApis = _.mapValues(spec.apis, (api, apiName) => {
        var _a, _b;
        const apiResponse = (_b = (_a = api.responses) === null || _a === void 0 ? void 0 : _a[200]) === null || _b === void 0 ? void 0 : _b.schema;
        const newApiResponse = PontxSpec.PontJsonSchema.mapPontxSchema(apiResponse, transformOas2Schema);
        return fp.set("responses.200.schema", newApiResponse, api);
    });
    const allDefs = Object.assign(Object.assign({}, spec.definitions), newDefs);
    const newAllDefs = _.mapValues(allDefs, (defSchema, defName) => {
        return PontxSpec.PontJsonSchema.mapPontxSchema(defSchema, (childSchema) => {
            if (childSchema === defSchema) {
                return defSchema;
            }
            return transformOas2Schema(childSchema);
        });
    });
    return Object.assign(Object.assign({}, spec), { apis: allApis, definitions: newAllDefs });
};
const transformSchema = (spec, schemaMapper) => {
    const newDefs = {};
    const refTransformer = (isTopLevel) => (schema) => {
        const { originRef, templateArgs, typeName } = schema, rest = __rest(schema, ["originRef", "templateArgs", "typeName"]);
        if (isTopLevel) {
            return schema;
        }
        if (typeName) {
            return Object.assign(Object.assign({}, rest), { $ref: "#/definitions/" + schema.typeName });
        }
        return schema;
    };
    const requiredTransformer = (schema) => {
        if (schema.properties && !schema.required) {
            return Object.assign(Object.assign({}, schema), { required: Object.keys(schema.properties) });
        }
        return schema;
    };
    const schemaTransformer = (isTopLevel) => (schema) => {
        const transformers = [
            refTransformer(isTopLevel),
            requiredTransformer,
            (schema) => {
                if (schema.properties && !schema.additionalProperties) {
                    return Object.assign(Object.assign({}, schema), { additionalProperties: false });
                }
                return schema;
            },
            schemaMapper,
        ];
        return transformers.reduce((result, transformer) => {
            return transformer(result);
        }, schema);
    };
    const allApis = _.mapValues(spec.apis, (api, apiName) => {
        var _a, _b;
        const apiResponse = (_b = (_a = api.responses) === null || _a === void 0 ? void 0 : _a[200]) === null || _b === void 0 ? void 0 : _b.schema;
        const newApiResponse = PontxSpec.PontJsonSchema.mapPontxSchema(apiResponse, schemaTransformer(false));
        return fp.set("responses.200.schema", newApiResponse, api);
    });
    const allDefs = Object.assign(Object.assign({}, spec.definitions), newDefs);
    const newAllDefs = _.mapValues(allDefs, (defSchema, defName) => {
        return PontxSpec.PontJsonSchema.mapPontxSchema(defSchema, (childSchema) => {
            if (childSchema === defSchema) {
                return schemaTransformer(true)(defSchema);
            }
            return schemaTransformer(false)(childSchema);
        });
    });
    return Object.assign(Object.assign({}, spec), { apis: allApis, definitions: newAllDefs });
};
exports.default = DefaultPontxMocksPlugin;
//# sourceMappingURL=index.js.map